/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getPredicates;

import java.util.Collection;
import java.util.UUID;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.utils.NameUtils;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.common.Writes;

@Fails
public class GetPredicatesWithAssertionsTest6 extends WriteReadTest {

    private Resource type;
    private Resource type2;
    private Resource type3;
    private Resource named1;
    private Resource named2;

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {

        //type2 = graph.newResource();
        //graph.claim(type2, L0.Inherits, L0.Entity);
        //type3 = graph.newResource();
        //graph.claim(type3, L0.Inherits, L0.Entity);
        type = graph.newResource();
        graph.claim(type, L0.Inherits, L0.Entity);

        //graph.claim(type, L0.Inherits, type2);
        //graph.claim(type, L0.Inherits, type3);
        
        named1 = Writes.named(graph, UUID.randomUUID().toString());
        named2 = Writes.named(graph, UUID.randomUUID().toString());
        
        //graph.claim(type, L0.HasName, named1);
        //graph.claim(type, L0.ConsistsOf, named2);


        graph.claim(type, L0.Asserts, Writes.assertion(graph, L0.ConsistsOf, named1));
        graph.claim(type, L0.Asserts, Writes.assertion(graph, L0.HasName, named2));
       // graph.claim(type, L0.Asserts, Writes.assertion(graph, L0.HasName, named1));
		
	}
	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
		
        Collection<Resource> result = graph.getPredicates(type);
        assertNotNull("Null not allowed", result);

        for (Resource r: result) {
            System.out.println("Resrouce: " + NameUtils.getSafeName(graph, r, true));
        	//System.out.println(TestingUtils.predicateName(L0, graph, r));
        }
        int size = result.size();
        assertTrue("Wrong number of predicates: " + size,
        		(size == 2));
        System.out.println(graph.isSubrelationOf(L0.Inherits, L0.DependsOn));
      
        //assertTrue(Tests.contains(predicates));
        //assertTrue(Tests.contains(predicates, L0.SupertypeOf, named2));
    }
	
	/*
	@Override
	protected void read(ReadGraph graph) throws DatabaseException {
		
        Collection<Statement> consists = graph.getAssertedStatements(type, L0.ConsistsOf);

        assertTrue(Tests.contains(consists, type, L0.ConsistsOf, named1));
        assertTrue(Tests.contains(consists, type2, L0.ConsistsOf, named1));
        assertTrue(Tests.contains(consists, type3, L0.ConsistsOf, named1));
        assertTrue(consists.size() == 3);
	}
    */
}
