/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getSingleStatement;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.ManyObjectsForFunctionalRelationException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.WriteReadTest;

@Fails
public class GetSingleStatementTest22 extends WriteReadTest {

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {
    	Resource type = graph.newResource();
    	Resource l1 = graph.newResource();
    	Resource l2 = graph.newResource();
    	Resource ass1 = graph.newResource();
    	Resource ass2 = graph.newResource();
    	graph.claim(type, L0.Inherits, L0.Entity);
    	graph.claim(ass1, L0.InstanceOf, null,  L0.Assertion);
        graph.claim(ass2, L0.InstanceOf, null,  L0.Assertion);
    	graph.claim(type, L0.Asserts, ass1);
    	graph.claim(type, L0.Asserts, ass2);
    	graph.claim(ass1, L0.HasPredicate, L0.HasName);
    	graph.claim(ass1, L0.HasObject, l1);
    	graph.claim(ass2, L0.HasPredicate, L0.HasName);
    	graph.claim(ass2, L0.HasObject, l2);
    	graph.claim(written, L0.InstanceOf, null, type);
	}
	
	@Override
	protected void read(ReadGraph graph) throws DatabaseException {
		try {
			assertNotNull("Null not allowed", graph.getSingleStatement(written, L0.HasProperty));
        } catch (ManyObjectsForFunctionalRelationException e) {
            return;
        } catch(Throwable t) {
            fail("Wrong exception was thrown " + t.getClass().getCanonicalName());
        }
        fail("No exception was thrown!");	
	}
	
}
