/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getValue;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetValueTest5 extends WriteReadTest {

        Resource instance;
        float val[] = {0.1F, 0.2F};
        @Override
        protected void write(WriteGraph graph) throws DatabaseException {
            instance = graph.newResource();
            graph.claim(instance, L0.InstanceOf, null,  L0.FloatArray);
            graph.claimValue(instance, val);
        }
        
        @Override
        protected void read(ReadGraph graph) throws DatabaseException {
        	try {
                float[] result =  graph.getValue(instance);
                assertNotNull("Null response not allowed", result);
                assertTrue("Invalid result", (result.length==2 && result[0]==val[0] && result[1]==val[1]));
            } catch (Exception e) {
            	fail("Exception: " + e.getClass().getCanonicalName());
            }
        }
        
}