package org.simantics.db.tests.api.story;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.api.story.misc.DataModelTest;
//import org.simantics.db.tests.api.story.misc.GenerateStructuralTest;
import org.simantics.db.tests.api.story.misc.QuerySemanticsTest;
import org.simantics.db.tests.api.story.misc.SyntheticModellingTest;
import org.simantics.db.tests.api.story.misc.TextIndexingTest;
import org.simantics.db.tests.api.story.sessionGarbageCollection.CollectDuringWriteAndRead;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
	// misc
    DataModelTest.class,
//    GenerateStructuralTest.class,
    QuerySemanticsTest.class,
    SyntheticModellingTest.class,
    TextIndexingTest.class,
    // sessionGarbageCollection
    CollectDuringWriteAndRead.class
})
public class SuiteStory {

	@BeforeClass
    public static void setUp() {
		try {
			Tests.freshDatabase();
		} catch (Exception e) {
			Logger.defaultLogError(e);
		}
    }
	
}
