/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.clusterControl;

import org.junit.Test;
import org.simantics.db.WriteGraph;
import org.simantics.db.service.ClusterControl;
import org.simantics.db.service.ClusteringSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.db.testing.common.WriteQuery;

/**
 * Creates large amount of instances in multiple transactions
 * and the tries to verify that instances are written into the database.
 * 
 * @author Marko Luukkainen <marko.luukkainen@vtt.fi>
 *
 */
public class WriteNewResourceIntoCollectedCluster extends ExistingDatabaseTest {
	
	@Test
	public void test() throws Exception{

        final long clusterId = getSession().getService(ClusteringSupport.class).getCluster(getSession().getRootLibrary());

        getSession().getService(ClusterControl.class).collectClusters(Integer.MAX_VALUE);
        
        getSession().syncRequest(new WriteQuery(this) {
            @Override
            public void run(WriteGraph g) throws Throwable {
                
                g.newResource(clusterId);
                
            }
            
        });
        
        checkException();
		
	}

}
