/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.undoRedoSupport;

import org.junit.Test;
import org.simantics.db.Session;
import org.simantics.db.service.UndoRedoSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;

/**
 * Test case description missing!
 */
public class UndoTest07 extends ExistingDatabaseTest {

	@Test
    public void testUndo7() throws Exception {

    	Session session = getSession();
        final UndoRedoSupport support = session.getService(UndoRedoSupport.class);
        try {
            Context c1 = new Context(session, support);
            c1.create();
            c1.check();
            c1.add();
            c1.check();
            c1.addAppend();
            c1.check();

            c1.undo();
            c1.check();

            c1.add();
            c1.check();
            c1.addAppend();
            c1.check();

            Context c2 = new Context(session, support);
            c2.create();
            c2.check();
            c2.add();
            c2.check();
            c1.addAppend();
            c2.check();

            c1.undo();
            c1.check();
            
            c2.undo();
            c2.check();
        } catch (Throwable t) {
            fail("Test failed with exception " + t);
        }
    }
}
