/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.undoRedoSupport;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.WriteRequest;
import org.simantics.db.common.utils.OrderedSetUtils;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.UndoRedoSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;

/**
 * Test case description missing!
 */
public class UndoTest11 extends ExistingDatabaseTest {
    
	@Test
    public void testUndo11() throws Exception {

    	Session session = getSession();
        final UndoRedoSupport support = session.getService(UndoRedoSupport.class);
        try {
            UndoTestOrderedSet11 c1 = new UndoTestOrderedSet11(session, support);
            List<Resource> elements = new ArrayList<Resource>(); 
            Resource list = c1.create(elements);
            List<Resource> elements2 = new ArrayList<Resource>();
            elements2.addAll(elements);
            c1.modify(list, elements2);
            c1.check(list, elements2);
            c1.undo();
            c1.check(list, elements);
        } catch (Throwable t) {
            fail("Test failed with exception ", t);
        }
    }
    class UndoTestOrderedSet11 extends UndoTestOrderedSet {
        UndoTestOrderedSet11(Session session, UndoRedoSupport support) {
            super(session, support);
        }
        void modify(final Resource list, final List<Resource> els)
        throws DatabaseException {
            session.syncRequest(new WriteRequest() {
                @Override
                public void perform(WriteGraph g) throws DatabaseException {
                    g.markUndoPoint();
                    FirstLast fl = getFirstLast(g, list, els);
                    if (null == fl.first)
                        return;
                    Resource el = g.newResource();
                    OrderedSetUtils.add(g, list, el);
                    OrderedSetUtils.remove(g, list, el);
                }
            });
        }
    }
}
