/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.support.virtualGraphSupport;

import java.util.List;
import java.util.UUID;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.Session;
import org.simantics.db.VirtualGraph;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.common.request.WriteResultRequest;
import org.simantics.db.common.utils.OrderedSetUtils;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.VirtualGraphSupport;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.TestCleanDb;

public class VirtualGraphTest5 extends TestCleanDb {
	
	@Test
	@Fails
	public void test() throws DatabaseException {
		
		Session session = getSession();
        final VirtualGraphSupport support = session.getService(VirtualGraphSupport.class);
        final VirtualGraph virtual = support.getMemoryPersistent(UUID.randomUUID().toString());
		
        final Resource list = session.syncRequest(new WriteResultRequest<Resource>(virtual) {

			@Override
			public Resource perform(WriteGraph graph) throws DatabaseException {
				return graph.newResource();
			}
			
        });
        
		session.syncRequest(new WriteResultRequest<Resource>(virtual) {

			@Override
			public Resource perform(WriteGraph graph) throws DatabaseException {
				Resource element1 = graph.newResource();
				OrderedSetUtils.addFirst(graph, list, element1);
				OrderedSetUtils.addFirst(graph, list, graph.newResource());
				OrderedSetUtils.addFirst(graph, list, graph.newResource());
				OrderedSetUtils.remove(graph, list, element1);
				//OrderedSetUtils.addFirst(graph, list, graph.newResource());
				return list;
			}
			
		});
		
		session.syncRequest(new ReadRequest() {

			@Override
			public void run(ReadGraph graph) throws DatabaseException {
				List<Resource> set = OrderedSetUtils.toList(graph, list);
				System.err.println("set=" + set.size());
			}
			
		});
		
	}

}
