/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.client;


import org.junit.Test;
import org.simantics.db.Session;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.service.ClusteringSupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;

/**
 * Tests that reserving cluster identifier works.
 * Note that this test makes assumptions on implementatioin.
 */
public class ReserveIdsTest1 extends ExistingDatabaseTest {
    @Test
    public void test() throws DatabaseException {
        Session s = getSession();
        ClusteringSupport cs = s.getService(ClusteringSupport.class);
        long cid1 = cs.createCluster();
        for (int i=0; i<100; ++i)
            cs.createCluster();
        long cid2 = cs.createCluster();
        assertTrue(cid2 == cid1 + 101);
   }
}