/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.scalability;

import org.simantics.db.Resource;
import org.simantics.db.common.TransactionPolicyKeep;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.request.WriteInterface;
import org.simantics.db.service.TransactionPolicySupport;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.db.tests.performance.read.HierarchicalNames;
import org.simantics.layer0.Layer0;

public class WriteHierarchicalNames extends ExistingDatabaseTest {

	final private static String name = "name";
	
	// 512k nodes
	int[] sizes = { 122, 64, 64 };
	
	private Resource time(String label, WriteInterface<Resource> request) throws DatabaseException {

		long start = System.nanoTime();
		Resource result = getSession().sync(request);
		long duration = System.nanoTime() - start;
		System.out.println(label + " = " + 1e-9*duration);
		return result;
		
	}
	
	public void test() throws Exception {
		
		Layer0.getInstance(getSession());

		getSession().registerService(TransactionPolicySupport.class, new TransactionPolicyKeep());
		
		time("writeOnly", HierarchicalNames.writeOnly(name, sizes));
		time("writeOnly2", HierarchicalNames.writeOnly2(name, sizes));
		time("write", HierarchicalNames.write(name, sizes));
		time("write2", HierarchicalNames.write2(name, sizes));

	}

}
